#!/hint/bash -euE
# Copyright (C) 2018  Luke Shumaker
# SPDX-License-Identifier: AGPL-3.0-or-later

packages+=(
	git
)

for pkgbuild in abs/*/PKGBUILD*; do
	mapfile -t _depends < <(
		cd "${pkgbuild%/*}"
		sudo -u "#$(stat -c %u -- "${pkgbuild##*/}")" \
			makepkg --printsrcinfo -p "${pkgbuild##*/}" \
		| sed -nE -e 's/^\s+(|make|check)depends(|_\S*) = //p' -e '/^\s*pkgname/q'
	)
	cache_packages+=("${_depends[@]}")
done
